<template>
  <div class="col-md-12">
    <div class="filters">
      <div class="input-wrapper">
          <input type="text" v-model="search" placeholder="Search">
      </div>
      <div class="select-wrapper">
        <label>Row to show: </label>
        <select v-model="pageSize" class="select-box">
            <option value="5">5</option>
            <option value="10">10</option>
            <option value="25">25</option>
            <option value="50">50</option>
        </select>
      </div>
    </div>
    <div class="table-responsive">
      <table class="table table-striped table-bordered">
          <thead>
              <tr>
                  <th scope="col">id <i class="fas fa-sort-alpha-down float-right"></i></th>
                  <th scope="col" @click="sort('name')">Name</th>
                  <th scope="col" @click="sort('amount')">amount <i class="fas fa-sort-alpha-down float-right"></i></th>
                  <th scope="col" @click="sort('date')">date <i class="fas fa-sort-alpha-down float-right"></i></th>
                  <th scope="col">description <i class="fas fa-sort-alpha-down float-right"></i></th>
              </tr>
          </thead>
          <tbody>
              <tr v-for="(data, index) in (sortedActivity, filteredList)" :key="index">
                <td>{{data.id}}</td>
                <td>{{data.name}}</td>
                <td>{{data.amount}}</td>
                <td>{{data.date | formatDate}}</td>
                <td>
                    <LiveEdit v-model="data.description" :data="data" value="data.description"/>
                </td>
              </tr>
          </tbody>
      </table>
    </div>
    <div class="button-wrapper">
        <button @click="prevPage" class="button small"><i class="fas fa-arrow-left"></i> Previous</button>
        <button @click="nextPage" class="button small">Next <i class="fas fa-arrow-right"></i></button>
    </div>
  </div>
</template>

<script>
/*eslint-disable*/
import LiveEdit from './LiveEdit';
import moment from 'moment'
import { log } from 'util';
export default {
  data() {
    return {
        currentSort: 'name',
        currentSortDir: 'desc',
        search: '',
        searchSelection: '',
        pageSize: 5,
        currentPage: 1
    }
  },
  props: {
   data: {
    type: Array,
    required: true
   }
  },
  methods:{
    sort(s) {
      if(s === this.currentSort) {
        this.currentSortDir = this.currentSortDir==='asc'?'desc':'asc';
      }
      this.currentSort = s;
    },
    nextPage() {
      if((this.currentPage*this.pageSize) < this.data.length) this.currentPage++;
    },
    prevPage() {
      if(this.currentPage > 1) this.currentPage--;
    }
  },
  components: {
    LiveEdit
  },
  filters: {
    formatDate(val) {
        if (!val) { return '-' }
        return moment(val).format("MM/DD/YY h:mm a")
    },
    trimLength(val) {
        if (val.length < 200) { return val }
        return `${val.substring(0, 200)}...`
    }
  },
  computed: {
    sortedActivity() {
      return this.data.sort((a,b) => {
        let modifier = 1;
        if(this.currentSortDir === 'desc') modifier = -1;
        if(a[this.currentSort] < b[this.currentSort]) return -1 * modifier;
        if(a[this.currentSort] > b[this.currentSort]) return 1 * modifier;
        return 0;
      }).filter((row, index) => {
        let start = (this.currentPage-1)*this.pageSize;
        let end = this.currentPage*this.pageSize;
        if(index >= start && index < end) return true;
      });
    },
    filteredList () {
      return this.data.filter((_data) => {
        let date = _data.date.toLowerCase().match(this.search.toLowerCase());
        return date
      }).filter((row, index) => {
        let start = (this.currentPage-1)*this.pageSize;
        let end = this.currentPage*this.pageSize;
        if(index >= start && index < end) return true;
      });
    }
  },
  created () {
  },
}
</script>
